/*
Copyright (C) 2004  The PARI group.

This file is part of the PARI package.

PARI/GP is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation. It is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY WHATSOEVER.

Check the License for details. You should have received a copy of it, along
with the package; see the file 'COPYING'. If not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#include "pari.h"
#include "tree.h"
#include "stack.h"

static stack s_opcode, s_data;

static long *opcode;
static GEN *data;
static long offset=-1;

void
getcodepos(long *sop, long *sdat, long *off)
{
  *sop=s_opcode.n;
  *sdat=s_data.n;
  *off=offset;
  offset=s_data.n-1;
}

GEN
getclosure(long sop, long sdat, long off)
{
  long lop =s_opcode.n+1-sop;
  long ldat=s_data.n+1-sdat;
  GEN cl=cgetg(3,t_VEC);
  long i;
  gel(cl,1) = cgetg(lop,  t_VECSMALL);
  gel(cl,2) = cgetg(ldat, t_VEC);
  for(i=1;i<lop;i++)
    mael(cl, 1, i) = opcode[i+sop-1];
  s_opcode.n=sop;
  for(i=1;i<ldat;i++)
    gmael(cl, 2, i) = data[i+sdat-1];
  s_data.n=sdat;
  offset=off;
  return cl;
}

void
op_push(int o, long x)
{
  int n=stack_new(&s_opcode);
  int m=stack_new(&s_opcode);
  opcode[n]=o;
  opcode[m]=x;
}

long
data_push(GEN x)
{
  int n=stack_new(&s_data);
  data[n] = x;
  return n-offset;
}

void
init_compiler2(void)
{
  stack_init(&s_opcode,sizeof(*opcode),(void **)&opcode);
  stack_init(&s_data,sizeof(*data),(void **)&data);
}


